diff -Nrc2 fontutils-0.5/imageto/main.c fontutils-0.6/imageto/main.c
*** fontutils-0.5/imageto/main.c	Fri Aug 21 16:14:20 1992
--- fontutils-0.6/imageto/main.c	Sat Oct 24 05:14:04 1992
***************
*** 20,36 ****
  
  #include <ctype.h>
  #define CMDLINE_NO_DPI /* It's not in the input filename.  */
  #include "cmdline.h"
  #include "getopt.h"
  #include "gf.h"
- #include "libfile.h"
  #include "report.h"
  
! #include "bb-outline.h"
! #include "bitmap2.h"
! #include "encoding.h"
! #include "epsf.h"
! #include "extract.h"
! #include "image-char.h"
  #include "image-header.h"
  #include "input-img.h"
--- 20,32 ----
  
  #include <ctype.h>
+ 
  #define CMDLINE_NO_DPI /* It's not in the input filename.  */
  #include "cmdline.h"
+ #include "encoding.h" /* For `DEFAULT_ENCODING'.  */
  #include "getopt.h"
  #include "gf.h"
  #include "report.h"
  
! #include "ifi.h" /* For `encoding_name'.  */
  #include "image-header.h"
  #include "input-img.h"
***************
*** 37,52 ****
  #include "input-pbm.h"
  #include "main.h"
! #include "strips.h"
! 
! 
! /* For temporary debugging.  */
! boolean debug;
  
- /* The design size of the font we're creating.  (-designsize)  */
- real design_size = 10.0;
  
! /* The name of the encoding file specified by the user, and the
!    structure we parse it into.  (-encoding)  */
! static string encoding_name = NULL;
  
  /* Pointers to functions based on input format.  (-input-format)  */
--- 33,43 ----
  #include "input-pbm.h"
  #include "main.h"
! #include "out-chars.h"
! #include "out-epsf.h"
! #include "out-strips.h"
  
  
! /* General information about the image.  Set by the input routines.  */
! image_header_type image_header;
  
  /* Pointers to functions based on input format.  (-input-format)  */
***************
*** 56,88 ****
  boolean (*image_get_scanline) (one_byte *) = NULL;
  
  /* Show every scanline on the terminal as we read it?  (-trace-scanlines) */
  boolean trace_scanlines = false;
- 
- /* General information about the image.  */
- image_header_type image_header;
  
  /* Private variables.  */
  
! /* A list of the image rows on which the baselines occur.  The end of
!    the list is marked with an element -1.  (-baselines)  */
! static int *baseline_list = NULL;
! 
! /* If a bounding box encloses more black (as a percentage) than this, it
!    is cleared.  (-clean-threshold)  */
! static real clean_threshold = .6;
! 
! /* If set, write an EPSF file.  (-epsf)  */
! static boolean do_epsf = false;
! 
! /* If set, prints diagnostics about which boxes are and aren't cleaned. 
!    (-print-clean-info)  */ 
! static boolean print_clean_info = false;
! 
! /* The name of the IFI file.  (-info-file)  */
! static string info_filename = NULL;
! 
! /* The non-extension and non-directory part of the filename for the
!    input image.  */
! static string input_rootname;
  
  /* The suffix for the image file.  */
--- 47,60 ----
  boolean (*image_get_scanline) (one_byte *) = NULL;
  
+ /* The filename for the input image.  */
+ string input_name;
+ 
  /* Show every scanline on the terminal as we read it?  (-trace-scanlines) */
  boolean trace_scanlines = false;
  
  /* Private variables.  */
  
! /* The design size of the font we're creating.  (-designsize)  */
! static real design_size = 10.0;
  
  /* The suffix for the image file.  */
***************
*** 89,100 ****
  static string input_extension;
  
! /* How many character reports fit on a line.  */
! static unsigned nchars_per_line;
! 
! /* Find about this many characters in the image, then stop.  This is
!    useful only for testing, because converting the entire image takes a long
!    time.  So we might in truth output a few more characters than
!    specified here.  (-nchars)  */
! static unsigned nchars_wanted = MAX_CHARCODE + 1;
  
  /* The name of the file we're going to write.  (-output-file) */
--- 61,66 ----
  static string input_extension;
  
! /* If set, write an EPSF file.  (-epsf)  */
! static boolean output_epsf = false;
  
  /* The name of the file we're going to write.  (-output-file) */
***************
*** 101,119 ****
  static string output_name;
  
- /* Says whether to print the row numbers of each character as we go, 
-    so that the user can decide how to adjust jumping baselines. 
-    (-print-guidelines)  */
- static boolean print_guidelines = false;
- 
- /* Says which characters we should process.  This is independent of the
-    ordering in the font file.  (-range) */
- static int starting_char = 0;
- static int ending_char = MAX_CHARCODE;
- 
- /* Where the baseline of the current row is in the image.  The first row
-    is #1, and so on.  We start over at row 1 at each image row.*/
- static unsigned row_baseline;
- static unsigned row_height;
- 
  /* If set, make each ``character'' a (more or less) constant number of
     scanlines.  (-strips) */
--- 67,70 ----
***************
*** 120,136 ****
  static boolean do_strips = false;
  
- /* How many boxes total the character take up.  */
- static unsigned total_boxes_expected;
  
- 
- static gf_char_type bitmap_to_gf_char
-   (bitmap_type, real, bounding_box_type, image_char_type);
- static void clean_bitmap (bitmap_type *, int, int);
- static boolean do_image_line
-   (bitmap_type, unsigned *, unsigned *, real, image_char_list_type);
- static void extract_chars (image_header_type);
- static image_char_list_type read_ifi_file (unsigned *);
- static unsigned output_chars
-   (bounding_box_list_type, bitmap_type, real, image_char_list_type, unsigned);
  static string read_command_line (int, string[]);
  static void set_img_input_format (void);
--- 71,75 ----
***************
*** 139,144 ****
  
  /* We have three different strategies for processing the image:
!      1) (-strips) takes a constant number of scanlines as each character,
!      2)  (normal) analyze the image and write out the ``true'' characters,
       3)   (-epsf) write out the image as an Encapsulated PostScript file.
     
--- 78,83 ----
  
  /* We have three different strategies for processing the image:
!      1)  (normal) analyze the image and write out the ``true'' characters,
!      2) (-strips) takes a constant number of scanlines as each character,
       3)   (-epsf) write out the image as an Encapsulated PostScript file.
     
***************
*** 157,165 ****
  main (int argc, string argv[])
  {
!   string input_name = read_command_line (argc, argv);
!   boolean writing_gf = !do_epsf;
!   
!   set_input_format (input_name);
    
    /* Open the main input file.  */
    (*image_open_input_file) (extend_filename (input_name, input_extension));
--- 96,115 ----
  main (int argc, string argv[])
  {
!   boolean writing_gf;
! 
!   input_name = read_command_line (argc, argv);
!   writing_gf = !output_epsf;
    
+   set_input_format (input_name);  
+ 
+   /* If the input format is PBM, then they must also tell us the dpi.  */
+   if (image_open_input_file == pbm_open_input_file 
+       && image_header.hres == 0)
+     {
+       fprintf (stderr, "If you use PBM format, you must supply the dpi.\n");
+       fprintf (stderr, "For more information, use ``-help''.\n");
+       exit (1);
+     }
+ 
    /* Open the main input file.  */
    (*image_open_input_file) (extend_filename (input_name, input_extension));
***************
*** 169,178 ****
    (*image_get_header) ();
  
-   /* We might use this in `read_ifi_file', so always set it.  */
-   input_rootname = remove_suffix (basename (input_name));
- 
    /* If the user didn't give an output name, use the input name.  */
    if (output_name == NULL)
!     output_name = input_rootname;
    
    /* If they didn't give an output name with a suffix, use ours.  */
--- 119,125 ----
    (*image_get_header) ();
  
    /* If the user didn't give an output name, use the input name.  */
    if (output_name == NULL)
!     output_name = remove_suffix (basename (input_name));
    
    /* If they didn't give an output name with a suffix, use ours.  */
***************
*** 187,191 ****
            output_name = concat5 (output_name, suffix, ".", dpi, "gf");
  	}
!       else if (do_epsf)
          output_name = concat (output_name, ".eps");
        else
--- 134,138 ----
            output_name = concat5 (output_name, suffix, ".", dpi, "gf");
  	}
!       else if (output_epsf)
          output_name = concat (output_name, ".eps");
        else
***************
*** 209,221 ****
           the TFM file get too big.  */
        design_size = 100.0;
!       write_chars_as_strips (image_header);
      }
!   else if (do_epsf)
      write_epsf (output_name, image_header);
    else
!     extract_chars (image_header);
  
    /* Clean up.  */
!   if (verbose || print_clean_info)
      REPORT ("\n");
  
--- 156,168 ----
           the TFM file get too big.  */
        design_size = 100.0;
!       write_chars_as_strips (image_header, design_size);
      }
!   else if (output_epsf)
      write_epsf (output_name, image_header);
    else
!     write_image_chars (image_header, design_size);
  
    /* Clean up.  */
!   if (verbose)
      REPORT ("\n");
  
***************
*** 234,802 ****
  }
  
- /* Analyze the input image, outputting the characters we find.  */
- 
- static void
- extract_chars (image_header_type image_header)
- {
-   bitmap_type *image_bitmap;
-   unsigned nchars_done = 0;
- 
-   /* Read the image information.  This tells us to which character
-        each bounding box belongs, among other things.  */
-   image_char_list_type image_char_list
-     = read_ifi_file (&total_boxes_expected);
- 
-   /* Since we report (a lot) more information when `print_guidelines' is true,
-      we can fit fewer characters per line.  */
-   nchars_per_line = print_guidelines ? 1 : 11;
- 
-   /* The main loop also (and more commonly) exits when we've read the
-      entire image.  */ 
-   while (nchars_done < nchars_wanted)
-     {
-       unsigned *transitions;
- 
-       /* Read one line of characters in the image.  After this,
-          `image_bitmap' is, for example, `a...z', with blank columns at
-          the left and right.  Whatever is in the original image.  */
-       image_bitmap
-         = some_black_to_all_white_row (image_header.width, &transitions);
-       if (image_bitmap == NULL)
-         break; /* We've read the whole image file.  */
- 
-       if (baseline_list == NULL || *baseline_list == -1)
-         {
-          if (baseline_list != NULL)
-             WARNING ("imageto: Not enough baselines specified");
-           row_baseline = 0;
-         }
-       else
-         row_baseline = *baseline_list++;
- 
-       row_height = BITMAP_HEIGHT (*image_bitmap);
- 
-       /* If `do_image_line' fails, we're supposed to read the next
-          row in the image, and put it below the current line.  For
-          example, if a line has only an `!' on it, we will only get
-          the stem on the first call to `some_black_to_all_white_row'.  
-          We want to get the dot in there, too.  */
-       while (!do_image_line (*image_bitmap, transitions, &nchars_done,
-                              (real) image_header.hres, image_char_list))
-         {
-           bitmap_type *revised
-             = append_next_image_row (*image_bitmap, image_header.width,
-                                      &transitions);
-           if (revised == NULL)
-             FATAL ("imageto: Image ended in the midst of a character");
- 
-           free_bitmap (image_bitmap);
-           image_bitmap = revised;
-           if (baseline_list == NULL)
-             row_baseline = 0;
- 
- 	 row_height += BITMAP_HEIGHT (*image_bitmap);
-         }
- 
-       free_bitmap (image_bitmap);
-     }
- }
- 
- 
- /* Analyze and output all of the bitmap IMAGE, which is one line of type
-    in the original.  The resolution of the image is H_RESOLUTION, and
-    we've read NCHARS characters so far.  We use IMAGE_CHAR_LIST and the
-    transition vector TRANSITIONS, which has in it how IMAGE breaks into
-    characters.
-    
-    We return false if we need to be given another image row.  */
- 
- #define NEXT_TRANSITION()  ({						\
-   if (*transitions == BITMAP_WIDTH (image) + 1)				\
-     {									\
-       WARNING ("do_image_line: Expected more transitions");		\
-       break;								\
-     }									\
-   *transitions++;							\
- })
- 
- static boolean
- do_image_line (bitmap_type image, unsigned *transitions, unsigned *nchars, 
-                real h_resolution, image_char_list_type image_char_list)
- {
-   static unsigned box_count = 0;
-   bounding_box_type bb;
-   MIN_ROW (bb) = 0;
-   MAX_ROW (bb) = BITMAP_HEIGHT (image) - 1;
-   
-   /* `nchars_wanted' is an option to the program, defined at the top.  */
-   while (*nchars < nchars_wanted && *transitions != BITMAP_WIDTH (image) + 1)
-     {
-       int bb_offset = 0;
-       unsigned original_box_count = box_count;
-       bounding_box_list_type boxes = init_bounding_box_list ();
-       bitmap_type *char_bitmap = XTALLOC1 (bitmap_type);
-       bitmap_type *temp_bitmap = XTALLOC1 (bitmap_type);
- 
-       /* The first element of TRANSITIONS is white-to-black.
-          Thereafter, they alternate.  */
-       MIN_COL (bb) = NEXT_TRANSITION ();
-       MAX_COL (bb) = NEXT_TRANSITION ();
-       
-       /* After this, `char_bitmap' might be just an `a' (with blank
-          rows above and below, because `a' has neither a descender nor
-          an ascender), then `b', and so on.  In many specimens, some
-          characters overlap; for example, we might get `ij' as one
-          bitmap, instead of `i' and then `j'.  */
-       *char_bitmap = extract_subbitmap (image, bb);
-       *temp_bitmap = copy_bitmap (*char_bitmap);
- 
-       while (true)
-         {
-           bounding_box_list_type temp_boxes;
-           bounding_box_type previous_bb;
- 
-           /* If we've read all the bounding boxes expected, we're done.  */
-           if (box_count == total_boxes_expected)
-             break;
- 
-           /* If we've read more than we expected to, we're in trouble.  */
-           if (box_count > total_boxes_expected)
-             {
-               WARNING2 ("do_image_line: Read box #%u but expected only %u",
-                         box_count, total_boxes_expected);
-               /* No point in giving this message more than once.  */
-               total_boxes_expected = INT_MAX;
-             }
- 
-           /* Find bounding boxes around all the shapes in `char_bitmap'.
-              Continuing the `ij' example, this would result in four
-              bounding boxes (one for each dot, one for the dotless `i',
-              and one for the dotless `j').  */
-           temp_boxes = find_outline_bbs (*temp_bitmap, false, 0, 0);
- 
-           /* The subimages we've created all start at column zero.  But
-              we want to put the images side-by-side, instead of
-              overlaying them.  So we change the bounding box numbers.  */
-           offset_bounding_box_list (&temp_boxes, bb_offset);
- 
-           box_count += BB_LIST_LENGTH (temp_boxes);
-           append_bounding_box_list (&boxes, temp_boxes);
- 
-           /* See if the white column was in the middle of a character.  */
-           if (box_at_char_boundary_p (image_char_list, *nchars,
-                                       box_count - original_box_count))
-             break;
- 
-           /* It was.  We have to read more (horizontally) of the image,
-              if we have it.  If we don't, return false, so our caller
-              can read more (vertically). */
- 
- 	  free_bitmap (temp_bitmap);
- 
- 	  if (*transitions == BITMAP_WIDTH (image) + 1)
-             { /* Forget that we've seen this before.  */
-               box_count = original_box_count;
-               return false;
-             }
- 
- 	  previous_bb = bb;
- 	  MIN_COL (bb) = NEXT_TRANSITION ();
-           MAX_COL (bb) = NEXT_TRANSITION ();
- 	  bb_offset = MIN_COL (bb) - MAX_COL (previous_bb);
- 	  /* Leave in the white space between the character parts.  */
- 	  MIN_COL (bb) = MAX_COL (previous_bb);
-           
-           *temp_bitmap = extract_subbitmap (image, bb);
-           REPORT ("+");
-           if (temp_bitmap == NULL)
-             {
-               WARNING1 ("imageto: Expected more bounding boxes for `%d'",
-                        IMAGE_CHARCODE (IMAGE_CHAR (image_char_list, *nchars)));
-               break;
-             }
- 
-           /* The boxes `temp_bitmap' should be just to the right of the
-              bitmap we've accumulated in `char_bitmap'.  */
-           bb_offset += BITMAP_WIDTH (*char_bitmap);
- 
- 	  /* When this happens, it usually means that the IFI file
-              didn't specify enough bounding boxes for some character,
-              and so things are out of sync.  */
-           if (BITMAP_HEIGHT (*char_bitmap) != BITMAP_HEIGHT (*temp_bitmap))
-             {
-               WARNING ("imageto: Line ended inside a character");
-               break;
-             }
-           bitmap_concat (char_bitmap, *temp_bitmap);
-         }  /* while (true)  */
-         
-       free_bitmap (temp_bitmap);
- 
-       /* Convert the bits inside those bounding boxes into one (if not
-         overlapping with another) or more (if overlapping) characters
- 	in the GF font.  */
-       *nchars += output_chars (boxes, *char_bitmap, h_resolution,
-                                image_char_list, *nchars);
- 
-       free_bitmap (char_bitmap);
-       free_bounding_box_list (&boxes);
-     }
-   
-   return true;
- }
- 
- /* This macro figures out how the previous and next bounding boxes
-    overlap the current bounding box, which we assume is `BB_LIST_ELT
-    (boxes, this_box)'.  The variables we assign to, `left_edge' and
-    `right_edge', must be already declared.  We have to put the numbers
-    in the coordinate system of the bitmap of the single character we're
-    working on, instead of the coordinate system the bounding boxes
-    numbers are in, which is the group of characters we were sent.  */
- 
- #define SET_EDGES(bb)							\
-   left_edge								\
-     = this_box == 0							\
-       ? 0								\
-       : MAX_COL (BB_LIST_ELT (boxes, this_box - 1)) - MIN_COL (bb);	\
-   right_edge								\
-     = this_box == BB_LIST_LENGTH (boxes) - 1				\
-       ? BB_WIDTH (bb)							\
-       : MIN_COL (BB_LIST_ELT (boxes, this_box + 1)) - MIN_COL (bb);
- 
- 
- /* For each bounding box in the list BOXES, extract from IMAGE_BITMAP
-    and turn the resulting bitmap into a single character in the font. 
-    The information in IMAGE_CHAR_LIST maps bounding boxes to character codes;
-    consecutive bounding boxes may belong to the same character.  For
-    example, `i' will appear twice, once for the dot and once for the
-    stem.  We assume that all the bounding boxes for a given character
-    will appear in IMAGE_BITMAP.
-    
-    We return the number of characters (not bounding boxes) found,
-    including characters that were omitted.  */
- 
- static unsigned
- output_chars (bounding_box_list_type boxes, bitmap_type image_bitmap, 
- 	      real h_resolution, image_char_list_type image_char_list,
-               unsigned current_char)
- {  
-   static unsigned char_count = 0;
-   int left_edge, right_edge;
-   unsigned this_box;
-   boolean done[BB_LIST_LENGTH (boxes)];
-   unsigned number_written = 0;
-   
-   for (this_box = 0; this_box < BB_LIST_LENGTH (boxes); this_box++)
-     done[this_box] = false;
- 
-   for (this_box = 0; this_box < BB_LIST_LENGTH (boxes); this_box++)
-     {
-       bounding_box_type bb;
-       bitmap_type bitmap;
-       image_char_type c;
-       one_byte charcode;
-       gf_char_type gf_char;
-       
-       /* `done[this_box]' will be set if we get to a bounding box that
-          has already been combined with a previous one, because of
-          an alternating combination.  Since we never go backwards, we
-          don't bother to set `done' for every box we look at.  */
-       if (done[this_box])
-         continue;
-         
-       bb = BB_LIST_ELT (boxes, this_box);
-       c = IMAGE_CHAR (image_char_list, current_char++);
-       charcode = IMAGE_CHARCODE (c);
-       
-       if (charcode >= starting_char && charcode <= ending_char
-           && !IMAGE_CHAR_OMIT (c))
-         {
-           bitmap = extract_subbitmap (image_bitmap, bb);
-           
-           /* Remove extraneous blobs and such.  We have to do this when
-              we first have the bitmap, before anything has been combined.
- 	     Otherwise, the dot on the `i', for example, would get
-              cleaned away.  */
- 
-           SET_EDGES (bb);
-           clean_bitmap (&bitmap, left_edge, right_edge);
-         }
- 
-       while (IMAGE_CHAR_BB_COUNT (c)-- > 1)
-         {
-           unsigned combine_box;
-           
-           if (IMAGE_CHAR_BB_ALTERNATING (c))
-             {
-               /* Don't increment `this_box', since it is incremented at
-                  the end of the loop, and the next box is part of
-                  another character.  */
-               combine_box = this_box + 2;
-               /* Don't look at the second box again in the outer loop:  */
-               done[combine_box] = true;
-             }
-           else
-             combine_box = ++this_box;
- 
-           if (combine_box >= BB_LIST_LENGTH (boxes))
-             {
-               WARNING1 ("output_chars: Not enough outlines for char %u",
-                         (unsigned) charcode);
-               break;
-             }
- 
-           if (charcode >= starting_char && charcode <= ending_char
-               && !IMAGE_CHAR_OMIT (c))
-             {
-               /* Get the shape to combine with `bitmap'.  */
-               bounding_box_type next_bb = BB_LIST_ELT (boxes, combine_box);
-               bitmap_type next_bitmap
-                 = extract_subbitmap (image_bitmap, next_bb);
- 
-               SET_EDGES (bb);
-               clean_bitmap (&bitmap, left_edge, right_edge);
-               combine_images (&bitmap, next_bitmap, &bb, next_bb);
-               free_bitmap (&next_bitmap);
-             }
-         }
-       
-       if (charcode >= starting_char && charcode <= ending_char
-           && !IMAGE_CHAR_OMIT (c))
-         {
-           REPORT ("[");
-           gf_char = bitmap_to_gf_char (bitmap, h_resolution, bb, c);
-           gf_put_char (gf_char);
-           REPORT ("]");
-           /* This and the GF character's bitmap are the same, so we only
-              need to free one of the two.  */
-           free_bitmap (&bitmap);
-         }
-       else
-         REPORT ("x"); /* We're ignoring this character.  */
- 
-       REPORT1 ("%c", ++char_count % nchars_per_line ? ' ' : '\n');
-       number_written++;
-     }
-   
-   return number_written;
- }              
- 
- 
- #define BB_TO_CARTESIAN(x) 						\
-   (row_height - 1 - (x) - row_baseline 					\
-    - IMAGE_CHAR_BASELINE_ADJUST (image_char))
- 
- /* Derive the information necessary to output the font character from
-    the bitmap B, and return it.  The resolution of the bitmap is given in
-    pixels per inch as H_RESOLUTION.  The bounding box BB encloses the
-    character in the image coordinates.  We use BB, plus the global
-    `baseline', to determine the positioning of the GF character.  */
- 
- static gf_char_type
- bitmap_to_gf_char (bitmap_type b, real h_resolution,
-                    bounding_box_type bb, image_char_type image_char)
- {
-   gf_char_type gf_char;
-   real width_in_points;
-   charcode_type charcode = IMAGE_CHARCODE (image_char);
-   bounding_box_type cartesian_bb;  
-   
-   MIN_ROW (cartesian_bb) = BB_TO_CARTESIAN (MAX_ROW (bb));
-   MAX_ROW (cartesian_bb) = BB_TO_CARTESIAN (MIN_ROW (bb));
-   
-   REPORT1 ("%u", charcode);
-   
-   GF_CHARCODE (gf_char) = charcode;
-   GF_BITMAP (gf_char) = b;
-   GF_CHAR_MIN_COL (gf_char) = IMAGE_CHAR_LSB (image_char);
-   GF_CHAR_MAX_COL (gf_char) = GF_CHAR_MIN_COL (gf_char) + BITMAP_WIDTH (b);
-   GF_CHAR_MIN_ROW (gf_char) = MIN_ROW (cartesian_bb);
-   GF_CHAR_MAX_ROW (gf_char) = MAX_ROW (cartesian_bb);
- 
-   GF_H_ESCAPEMENT (gf_char) = (GF_CHAR_MAX_COL (gf_char)
-                                + IMAGE_CHAR_RSB (image_char));
- 
-   width_in_points = GF_H_ESCAPEMENT (gf_char) * POINTS_PER_INCH / h_resolution;
-   GF_TFM_WIDTH (gf_char) = real_to_fix (width_in_points / design_size);
- 
-   if (print_guidelines)
-     fprintf (stderr, " (%s) %d/%d",  IMAGE_CHARNAME (image_char),
- 	     MIN_ROW (cartesian_bb), MAX_ROW (cartesian_bb));
- 
-   return gf_char;
- }
- 
- 
- /* Find the bounding boxes of all outlines inside B.  For each of them
-    that are sufficiently black, white them out.  In the type specimens,
-    many characters overlap their neighbors by just a few pixels.  When
-    we extract the pixels inside the bounding box of the `d', say, a few
-    pixels of the `e' may creep in on the right.  We want to get rid of
-    those.  Other junk might show up due to dark spots on the page, and
-    we want to get rid of those, too.  Hence the test for ``sufficiently
-    black''.  */
- 
- static void
- clean_bitmap (bitmap_type *b, int left, int right)
- {
-   unsigned this_box;
-   bounding_box_list_type boxes 
-     = find_outline_bbs (*b, false, left, right);
-   
-   for (this_box = 0; this_box < BB_LIST_LENGTH (boxes); this_box++)
-     {
-       bounding_box_type bb = BB_LIST_ELT (boxes, this_box);
-       
-       /* If the bounding box encloses the entire character, we don't
-           have to bother checking how black it is.  */
-           
-       if (!(BB_WIDTH (bb) == BITMAP_WIDTH (*b)
-             && BB_HEIGHT (bb) == BITMAP_HEIGHT (*b)))
-         {
-           real average_gray;
-           unsigned this_row, this_col;
-           unsigned black_count = 0;
-           unsigned total_pixels = BB_WIDTH (bb) * BB_HEIGHT (bb);
-           
-           for (this_row = MIN_ROW (bb); this_row <= MAX_ROW (bb); this_row++)
-             for (this_col = MIN_COL (bb); this_col < MAX_COL (bb); this_col++)
-               {
-                 if (BITMAP_PIXEL (*b, this_row, this_col) == BLACK)
-                   black_count++;
-               }
-           average_gray = (real) black_count / total_pixels;
- 
-           if (print_clean_info)
-             fprintf (stderr, "\nCleaning %ux%u:", BITMAP_WIDTH (*b),
-                      BITMAP_HEIGHT (*b)); 
- 
- 	  if (average_gray >= clean_threshold)
-             {
-               if (print_clean_info)
-                 fprintf (stderr, " clearing %.2f. ", average_gray);
-               for (this_row = MIN_ROW (bb); this_row <= MAX_ROW (bb);
-                    this_row++)
-                 for (this_col = MIN_COL (bb); this_col < MAX_COL (bb);
-                      this_col++)
-                   BITMAP_PIXEL (*b, this_row, this_col) = WHITE;
-             }
-           else if (print_clean_info)
-             fprintf (stderr, " omitting %.2f. ", average_gray);
-         }
-     }
- }
- 
- /* Read an IFI file, which gives us some information about the
-    image we are going to read.  If `info_filename' is set (which the
-    user can do), use that for the name; otherwise, construct it from the
-    font name.
-    
-    See the documentation for full details and examples of IFI files.
-    Here we just sketch the bare bones.
-    
-    Each (non-blank, non-comment) line in this file represents a
-    ``character'' in the image, and has one to five entries, separated by
-    spaces and/or tabs.  Comments start with `%' and continue to the end
-    of the line.
-    
-    The first entry represents the character code.  See the documentation
-    for the various forms of charcodes.  We also allow `.notdef', meaning
-    the ``character'' should not be output in the font.  
-    
-    The second entry, if it exists, is an adjustment to the
-    baseline.  We move the baseline down for negative numbers, and up
-    for positive ones.  Default is zero.
-    
-    The third entry, if it exists, is the number of bounding boxes that
-    comprise this character.  If it is negative, the bounding boxes
-    are not consecutive in the image; instead, they alternate with
-    bounding boxes for some other character.
-    
-    The fourth and fifth entries, if they exist, are the left and right
-    side bearings, respectively.  */
-    
- static image_char_list_type
- read_ifi_file (unsigned *total_count)
- {
-   string line;
-   int bb_count;
-   image_char_list_type image_char_list = new_image_char_list ();
-   encoding_info_type encoding_info 
-     = read_encoding_file (encoding_name ? : DEFAULT_ENCODING);
-   
-   libfile_start (info_filename ? : input_rootname, "ifi");
- 
-   *total_count = 0;
- 
-   while ((line = libfile_line ()) != NULL)
-     {
-       image_char_type c;
-       string baseline_adjust_str, bb_count_str, charname;
-       string lsb_str, rsb_str;
-       string save_line = line; /* So we can free it.  */
-       
-       /* The character name.  */
-       charname = strtok (line, " \t");
-       
-       /* `libfile_line' should never return an empty line.  */
-       assert (charname != NULL);
-       
-       if (STREQ (charname, ".notdef"))
-         IMAGE_CHAR_OMIT (c) = true;
-       else
-         {
-           int n = encoding_number (encoding_info, charname);
-           
-           if (n == -1)
-             {
-               WARNING2 ("Character `%s' undefined in encoding %s",
-                         charname, ENCODING_SCHEME_NAME (encoding_info));
-               IMAGE_CHAR_OMIT (c) = true;
- 	    }
-           else
-             {
-     	      IMAGE_CHARCODE (c) = n;
-               IMAGE_CHARNAME (c) = xstrdup (charname);
-               IMAGE_CHAR_OMIT (c) = false;
- 	    }
-         }
- 
-       /* The baseline adjustment.  */
-       baseline_adjust_str = strtok (NULL, " \t");
-       IMAGE_CHAR_BASELINE_ADJUST (c)
-         = baseline_adjust_str == NULL ? 0 : atoi (baseline_adjust_str);
-       
-       /* The bounding box count.  */
-       bb_count_str = strtok (NULL, " \t");
-       bb_count = bb_count_str == NULL ? 1 : atoi (bb_count_str);
-       
-       if (bb_count < 0)
-         {
-           IMAGE_CHAR_BB_COUNT (c) = -bb_count;
-           IMAGE_CHAR_BB_ALTERNATING (c) = true;
-         }
-       else
-         {
-           IMAGE_CHAR_BB_COUNT (c) = bb_count;
-           IMAGE_CHAR_BB_ALTERNATING (c) = false;
-         }
- 
-       /* The left side bearing.  */
-       lsb_str = strtok (NULL, " \t");
-       IMAGE_CHAR_LSB (c) = lsb_str == NULL ? 0 : atoi (lsb_str);
-       
-       /* The right side bearing.  */
-       rsb_str = strtok (NULL, " \t");
-       IMAGE_CHAR_RSB (c) = rsb_str == NULL ? 0 : atoi (rsb_str);
-       
-       *total_count += IMAGE_CHAR_BB_COUNT (c);
-       append_image_char (&image_char_list, c);
-       free (save_line);
-     }
-   
-   libfile_close ();
-   return image_char_list;
- }
- 
  /* We are semi-clever about printing this, for the sake of huge images.  */
  
--- 181,184 ----
